import { SceneFinished, SceneStarts } from '../serenity/domain';
export declare const startOf: (scenario: Scenario) => SceneStarts;
export declare const endOf: (scenario: ExecutedScenario) => SceneFinished;
export declare const isPending: (scenario: ExecutedScenario) => boolean;
export interface TestError {
    name: string;
    message: string;
    showDiff: boolean;
    actual: string;
    expected: string;
    stack: string;
}
export interface Scenario {
    title: string;
    async: number;
    sync: boolean;
    timedOut: boolean;
    pending: boolean;
    type: string;
    file: string;
    parent: any;
    ctx: any;
    body(): string;
    fullTitle(): string;
}
export interface ExecutedScenario extends Scenario {
    time: any;
    duration: number;
    state: string;
    speed: string;
    err?: TestError;
}
