"use strict";
var domain_1 = require("../../serenity/domain");
var ProtractorNotifier = (function () {
    function ProtractorNotifier(runner) {
        this.runner = runner;
    }
    ProtractorNotifier.prototype.assignTo = function (stage) {
        this.stage = stage;
        this.stage.manager.registerInterestIn(ProtractorNotifier.Events_of_Interest, this);
    };
    ProtractorNotifier.prototype.notifyOf = function (event) {
        switch (event.constructor.name) {
            case domain_1.SceneFinished.name: return this.sceneFinished(event);
        }
    };
    ProtractorNotifier.prototype.sceneFinished = function (event) {
        if (this.runner.afterEach) {
            this.stage.manager.informOfWorkInProgress(this.runner.afterEach());
        }
    };
    return ProtractorNotifier;
}());
ProtractorNotifier.Events_of_Interest = [domain_1.SceneFinished];
exports.ProtractorNotifier = ProtractorNotifier;
//# sourceMappingURL=protractor_notifier.js.map