"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var recording_1 = require("../../../serenity/recording");
var browse_the_web_1 = require("../abilities/browse_the_web");
var hit_1 = require("./hit");
var Enter = (function () {
    function Enter(value) {
        this.value = value;
        this.interactions = [];
    }
    Enter.theValue = function (value) {
        return new Enter(value);
    };
    Enter.prototype.into = function (field) {
        this.target = field;
        this.interactions.push(new EnterValue(this.value, field));
        return this;
    };
    Enter.prototype.thenHit = function (key) {
        this.interactions.push(hit_1.Hit.the(key).into(this.target));
        return this;
    };
    Enter.prototype.performAs = function (actor) {
        return actor.attemptsTo.apply(actor, this.interactions);
    };
    return Enter;
}());
exports.Enter = Enter;
var EnterValue = (function () {
    function EnterValue(value, target) {
        this.value = value;
        this.target = target;
    }
    EnterValue.prototype.performAs = function (actor) {
        return browse_the_web_1.BrowseTheWeb.as(actor).locate(this.target).sendKeys(this.value);
    };
    return EnterValue;
}());
__decorate([
    recording_1.step('{0} enters "#value" into #target', recording_1.ActivityType.Interaction),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Object)
], EnterValue.prototype, "performAs", null);
//# sourceMappingURL=enter.js.map