import { Outcome, PhotoReceipt, RecordedActivity, RecordedScene } from './model';
export declare class DomainEvent<T> {
    value: T;
    timestamp: number;
    private type;
    constructor(value: T, timestamp?: number);
    toString(): string;
}
export declare class SceneStarts extends DomainEvent<RecordedScene> {
}
export declare class ActivityStarts extends DomainEvent<RecordedActivity> {
}
export declare class ActivityFinished extends DomainEvent<Outcome<RecordedActivity>> {
}
export declare class SceneFinished extends DomainEvent<Outcome<RecordedScene>> {
}
export declare class PhotoAttempted extends DomainEvent<PhotoReceipt> {
}
