"use strict";
var model_1 = require("../domain/model");
var activity_type_1 = require("./activity_type");
// todo: find a better name; it's not really a "description";
var ActivityDescription = (function () {
    function ActivityDescription(template, type) {
        this.template = template;
        this.type = type;
        this.argToken = /{(\d+)}/g;
        this.fieldToken = /#(\w+)/g;
    }
    ActivityDescription.prototype.interpolateWith = function (activity, argumentsOfThePerformAsMethod) {
        var name = this.determineName(this.template, activity, argumentsOfThePerformAsMethod);
        return (this.type === activity_type_1.ActivityType.Task)
            ? new model_1.RecordedTask(name)
            : new model_1.RecordedInteraction(name);
    };
    ActivityDescription.prototype.using = function (source) {
        return function (token, field) {
            switch ({}.toString.call(source[field])) {
                case '[object Function]': return source[field]();
                case '[object Array]': return source[field].join(', ');
                case '[object Object]': return source[field].toString();
                case '[object Undefined]': return token;
                default: return source[field];
            }
        };
    };
    ActivityDescription.prototype.determineName = function (template, activity, args) {
        return template.
            replace(this.fieldToken, this.using(activity)).
            replace(this.argToken, this.using(args));
    };
    return ActivityDescription;
}());
exports.ActivityDescription = ActivityDescription;
//# sourceMappingURL=activity_description.js.map