import { Activity } from '../screenplay';
import { StageManager } from '../stage';
import { ActivityType } from './activity_type';
export declare class Step {
    private stageManager;
    private activityType;
    constructor(stageManager: StageManager, activityType?: ActivityType);
    describedUsing<T extends Activity>(template: string): StepAnnotation<T>;
    private beforeStep(activity);
    private afterStep(activity);
    private onFailure(activity, error);
    private resultFrom(error);
}
export declare function step<A extends Activity>(stepDescriptionTemplate: string, type?: ActivityType): StepAnnotation<A>;
export declare type PerformAsMethodSignature = TypedPropertyDescriptor<(PerformsTasks) => PromiseLike<void>>;
export declare type StepAnnotation<T extends Activity> = (target: T, propertyKey: string, descriptor: PerformAsMethodSignature) => PerformAsMethodSignature;
