"use strict";
var _1 = require("../../");
var domain_1 = require("../domain");
var activity_description_1 = require("./activity_description");
var activity_type_1 = require("./activity_type");
var _ = require("lodash");
// todo: refactor
var Step = (function () {
    function Step(stageManager, activityType) {
        if (activityType === void 0) { activityType = activity_type_1.ActivityType.Task; }
        this.stageManager = stageManager;
        this.activityType = activityType;
    }
    Step.prototype.describedUsing = function (template) {
        var description = new activity_description_1.ActivityDescription(template, this.activityType), decorated = this;
        return function (target, propertyKey, descriptor) {
            var performAs = descriptor.value, decorator = _.cloneDeep(descriptor);
            decorator.value = function () {
                var _this = this;
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var recordedActivity = description.interpolateWith(this, args);
                return Promise.resolve()
                    .then(function () { return decorated.beforeStep(recordedActivity); })
                    .then(function () { return performAs.apply(_this, args); })
                    .then(function () { return decorated.afterStep(recordedActivity); }, function (e) { return decorated.onFailure(recordedActivity, e); });
            };
            return decorator;
        };
    };
    Step.prototype.beforeStep = function (activity) {
        this.stageManager.notifyOf(new domain_1.ActivityStarts(activity));
    };
    Step.prototype.afterStep = function (activity) {
        this.stageManager.notifyOf(new domain_1.ActivityFinished(new domain_1.Outcome(activity, domain_1.Result.SUCCESS)));
    };
    Step.prototype.onFailure = function (activity, error) {
        this.stageManager.notifyOf(new domain_1.ActivityFinished(new domain_1.Outcome(activity, this.resultFrom(error), error)));
        return Promise.reject(error);
    };
    Step.prototype.resultFrom = function (error) {
        var constructorOf = function (e) { return e && e.constructor ? e.constructor.name : ''; };
        // todo: sniff the exception to find out about the Result. Did the test fail, or was it compromised?
        return /AssertionError/.test(constructorOf(error))
            ? domain_1.Result.FAILURE
            : domain_1.Result.ERROR;
    };
    return Step;
}());
exports.Step = Step;
function step(stepDescriptionTemplate, type) {
    if (type === void 0) { type = activity_type_1.ActivityType.Task; }
    return new Step(_1.serenity.stageManager(), type).describedUsing(stepDescriptionTemplate);
}
exports.step = step;
//# sourceMappingURL=step_annotation.js.map