import { Stage, StageCrewMember } from '../../serenity/stage';
import { DomainEvent } from '../domain';
import { FileSystem, JSONObject } from '../io';
import { ActivityPeriod, RehearsalPeriod, ReportExporter, ScenePeriod } from './index';
import { ActivityReport, FullReport, SceneReport } from './serenity_bdd_report';
export declare function serenityBDDReporter(pathToReports?: string): StageCrewMember;
export declare class SerenityBDDReporter implements StageCrewMember {
    private fs;
    private static Events_of_Interest;
    private stage;
    constructor(fs: FileSystem);
    assignTo(stage: Stage): void;
    notifyOf(event: DomainEvent<any>): void;
    private persistReportFor({value});
}
/**
 * Transforms the tree structure of the RehearsalPeriod to a format acceptable by Protractor
 */
export declare class SerenityBDDReportExporter implements ReportExporter<JSONObject> {
    private errorExporter;
    private photoExporter;
    exportRehearsal(node: RehearsalPeriod): PromiseLike<FullReport>;
    exportScene(node: ScenePeriod): PromiseLike<SceneReport>;
    exportActivity(node: ActivityPeriod): PromiseLike<ActivityReport>;
    private dashified;
    private issuesCoveredBy(scene);
    private tagsFor(scene);
    private isAnIssue;
}
