"use strict";
var Actor = (function () {
    function Actor(name) {
        this.name = name;
        this.abilities = {};
    }
    Actor.named = function (name) {
        return new Actor(name);
    };
    Actor.prototype.whoCan = function () {
        var _this = this;
        var abilities = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            abilities[_i] = arguments[_i];
        }
        abilities.forEach(function (ability) {
            _this.abilities[ability.constructor.name] = ability;
        });
        return this;
    };
    Actor.prototype.abilityTo = function (doSomething) {
        if (!this.can(doSomething)) {
            throw new Error("I don't have the ability to " + doSomething.name + ", said " + this + " sadly.");
        }
        return this.abilities[doSomething.name];
    };
    Actor.prototype.attemptsTo = function () {
        var _this = this;
        var tasks = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            tasks[_i] = arguments[_i];
        }
        return tasks.reduce(function (previous, current) {
            return previous.then(function () { return current.performAs(_this); });
        }, Promise.resolve(null));
    };
    Actor.prototype.toSee = function (question) {
        return question.answeredBy(this);
    };
    Actor.prototype.toString = function () {
        return this.name;
    };
    Actor.prototype.can = function (doSomething) {
        return !!this.abilities[doSomething.name];
    };
    return Actor;
}());
exports.Actor = Actor;
//# sourceMappingURL=actor.js.map